Page MenuHomePhabricator

[PowerPC] Add clang options to control MMA support
ClosedPublic

Authored by bsaleil on Jun 8 2020, 6:20 PM.

Details

Summary

This patch adds frontend and backend options to enable and disable the PowerPC MMA operations added in ISA 3.1.
Instructions using these options will be added in subsequent patches.

This patch is part of the PowerPC MMA RFC that will be posted soon.

Diff Detail

Event Timeline

bsaleil created this revision.Jun 8 2020, 6:20 PM
bsaleil created this object with visibility "bsaleil (Baptiste Saleil)".
bsaleil created this object with edit policy "bsaleil (Baptiste Saleil)".
Herald added a project: Restricted Project. · View Herald TranscriptJun 8 2020, 6:20 PM
bsaleil edited the summary of this revision. (Show Details)Jun 19 2020, 6:06 PM
bsaleil changed the visibility from "bsaleil (Baptiste Saleil)" to "Public (No Login Required)".
bsaleil changed the edit policy from "bsaleil (Baptiste Saleil)" to "All Users".
bsaleil added a project: Restricted Project.
bsaleil edited reviewers, added: Restricted Project; removed: power-llvm-team.Jun 19 2020, 6:16 PM
bsaleil updated this revision to Diff 277466.Jul 13 2020, 9:43 AM
bsaleil edited the summary of this revision. (Show Details)Jul 13 2020, 2:54 PM
bsaleil added a project: Restricted Project.
bsaleil updated this revision to Diff 277580.Jul 13 2020, 3:00 PM

Also add target options with this patch

nemanjai accepted this revision.Jul 14 2020, 4:48 AM

Since clang will now add +/-mma to the TargetFeatures list, please add a test case that specifies -mattr=+/-mma to llc to show that llc accepts it.
Other than that, LGTM.

This revision is now accepted and ready to land.Jul 14 2020, 4:48 AM
bsaleil updated this revision to Diff 277858.Jul 14 2020, 9:05 AM

Add test to check that the mma option is supported by the targets.

amyk accepted this revision.Jul 17 2020, 2:17 PM

I think overall it LGTM.

llvm/lib/Target/PowerPC/PPCScheduleP9.td
42–43

nit: I think it would be good to add MMA to the comment here.

bsaleil updated this revision to Diff 281381.Jul 28 2020, 3:33 PM

Update diff so it can be applied to master.

This revision was automatically updated to reflect the committed changes.